;**********************************************************************
;                                                                     *
;    Filename:	    termo.asm                                         *
;    Date:          Aug 31 2005                                       *
;    File Version:                                                    *
;                                                                     *
;    Author:  Andrey Tarapat                                          *
;                                                                     *
;**********************************************************************
;    Notes:     -                *
;**********************************************************************


	list      p=16F628A            ; list directive to define processor
	#include <p16F628A.inc>        ; processor specific variable definitions

	__CONFIG _CP_OFF &_DATA_CP_OFF & _LVP_OFF & _BODEN_OFF & _MCLRE_ON & _WDT_OFF & _PWRTE_ON & _HS_OSC


;      :
	cblock 0x20
	temp		;     	
	PORTA_temp	;    
	Del_Counter	;     ( - .) 
	Del_Counter2
	Del_Counter3
	Int_Counter	; 
	Brightness	;  
	Br_prescaler; ,     Brightness
	Flash		;   
	Symb_Code	;    
	LED_Data	;      (  )
	LED_Num		;  
				;-  Video-RAM
	Symbol_1	;     1
	Symbol_2	;     2
	Symbol_3	;     3
	Symbol_4	;     4
	Symbol_5	;     5
	Symbol_6	;     6
	Symbol_7	;     7
	Symbol_8	;     8

	Key_1_Count	; ,       1
	Key_2_Count	; ,       2
	Key_3_Count	; ,       3
	Keyb_Status	;  
	Keyb_Last_St;     
	Keyb_Fronts	;    Keyb_Status
	
	i2c_adress	;     i2c
	i2c_data	;   ,     i2c
	i2c_slider	;       
	Hours		;  ()
	Minutes		;  ()
	Seconds		;  ()

	TCN75_Out	;   ,    ( )
	Temper_10_1	;    
	Temper_100	;     "1",   ( "12H")
	Temper_Stor	;    
	
	Mode		;  
	Timer_1		; -  ,   1    
	Timer_2		;  
	Key_Timer	;        (   . )

				;   
	Calc_1Lo	;    
	Calc_1Hi	;    
	Calc_2Lo	;    
	Calc_2Hi	;    
	Calc_cycle	;    
	Calc_TmpLo
	Calc_TmpHi	;   

	Out_Temp	;    
	Room_Temp	;    
	Cur_Temp	;        

	Reg_Status	; 
	Rass_OldLo
	Rass_OldHi	;       
	Rass_NewLo
	Rass_NewHi	;       

	Out_RegLo
	Out_RegHi	;  (    )
	Out_PrLo
	Out_PrHi	;    
	Out_IntLo
	Out_IntHi	;    
	Out_DifLo
	Out_DifHi	;    

	PWM			;   ,    
	PWM_Count	;  

	ctr
	bin1
	bin2
	bcd1
	bcd2
	bcd3

	Access_Level;     

	;       DS1307
	DS_Control	;   DS1307
				;   -
	Need_Temp	;    
	Ku			; 
;	Ki			; 
;	Kd			; 
	Ti			; 
	Td			; 
	Device_Conf	;  

	endc
;    ,    0x70...0x7F     
w_temp		EQU 0x70		;     
status_temp	EQU	0x71		;    
PCLATH_Temp EQU	0x72		; 

;    :
INIT_PORTA	EQU	b'00010000'	;   , RA4   ( )
INIT_PORTB	EQU	b'00000000'	; B   

INIT_CMCON	EQU	b'00000111'	;    
INIT_VRCON	EQU	b'00000000'	;      

INIT_OPTION	EQU	b'00000010'	;    OPTION.
					        ;Bit7=0   Pull-Up
							;Bit6=0   RA4/T0CKI (   )
							;Bit5=0   TMR0 -  
							;Bit4=0     RA4/T0CKI (  )
							;Bit3=0    TMR0
							;Bit2-0   1:8 (010)

INIT_INTCON	EQU	b'00100000'	;  
					        ;Bit7=0   
					        ;Bit5=0     TMR0

;  
Key_Pr		EQU .5			;      
Key_Long	EQU .100		;    (  )
T_Reg_Cycle	EQU	.10			;    10 

;  slave-   i2c
RTC_Adress	EQU	b'11010000'	;    DS1307
T_1_Adress	EQU	b'10010000'	; 1- 
T_2_Adress	EQU	b'10010001'	; 2- 
T_3_Adress	EQU	b'10010000'	; 3- 

VarToSave	EQU	.6			;  ,   DS1307

;  
Key			EQU .4			;      

Heat		EQU	.7			;  

							;  Keyb_Status
#DEFINE		Key_1_Pr	Keyb_Status,0	; 1  (   )
#DEFINE		Key_2_Pr	Keyb_Status,1	; 2  (   )
#DEFINE		Key_3_Pr	Keyb_Status,2	; 3  (   )
#DEFINE		Key_1_LP	Keyb_Status,3	; 1  
#DEFINE		Key_2_LP	Keyb_Status,4	; 2  
#DEFINE		Key_3_LP	Keyb_Status,5	; 3  
#DEFINE		Key_1_PrR	Keyb_Status,6	;  1   
#DEFINE		Key_1_LPR	Keyb_Status,7	;  1   

							;  Keyb_Fronts
#DEFINE		K_1_Pr_Fr	Keyb_Fronts,0	;    
#DEFINE		K_2_Pr_Fr	Keyb_Fronts,1	;    
#DEFINE		K_3_Pr_Fr	Keyb_Fronts,2	;    
#DEFINE		K_1_LP_Fr	Keyb_Fronts,3	;    
#DEFINE		K_2_LP_Fr	Keyb_Fronts,4	;    
#DEFINE		K_3_LP_Fr	Keyb_Fronts,5	;    
#DEFINE		Beep		Keyb_Fronts,6	;   

#DEFINE		SCL			PORTA,0			; 0   -  SCL  I2C
#DEFINE		SDA			TRISA^80h,1		; 1  TRIS -  SDA  I2C
#DEFINE		SDA_In  	PORTA,1			;   -  SDA    

#DEFINE		T_Corr		Mode,7			;    Mode=b'10000000'
#DEFINE		Set_Par 	Mode,6			;      Mode=b'01000000'
#DEFINE		Sec_Corr	Mode,5			;  ,   Write_Time_DS1307

#DEFINE		Sound_En	DS_Control,4	;     DS1307
#DEFINE		Sound_8k	DS_Control,1	;   8
#DEFINE		Sound_4k	DS_Control,0	;   4
#DEFINE		Sound_Out	DS_Control,7	;   DS     (..1)

#DEFINE		Beep_En		Device_Conf,0	;   
#DEFINE		Reg_Auto	Reg_Status,0	;  
#DEFINE		PWM_Tick	Reg_Status,1	;   
#DEFINE		Heat_On		Reg_Status,2	;   (   )


;**********************************************************************
		ORG     0x000			; processor reset vector
		goto	main			; go to beginning of program


;  
		ORG     0x004			;   

		;---      
		movwf   w_temp			;  w    
		swapf	STATUS,w		;       w
		clrf	STATUS			;   0 (      1)
		movwf	status_temp		;   STATUS
		bcf 	INTCON,T0IF		;   

;    
		;    ,    
;		movlw	HIGH Int_Sector
;		movwf	PCLATH
		movf	Int_Counter,w

;		clrf	PCLATH			;     
Int_Sector
		addwf	PCL,f			;W + PC -> PC
		goto	Symb_1_On		;  
		goto	Symb_Off		; 
		goto	Symb_2_On		; ..
		goto	Symb_Off
		goto	Symb_3_On
		goto	Symb_Off
		goto	Symb_4_On
		goto	Symb_Off
		goto	Symb_5_On
		goto	Symb_Off
		goto	Symb_6_On
		goto	Symb_Off
		goto	Symb_7_On
		goto	Symb_Off
		goto	Symb_8_On
		goto	Symb_Off

	;  

Symb_1_On
		movf	Brightness,w
		btfsc	Flash,7			;    1- 
		movwf	TMR0			;      TMR0
		
		movlw	b'11100001'		; W    1- 
		movwf	LED_Num			;     
		movf	Symbol_1,w		;  W    1- 
;		movwf	Symb_Code		;    
		goto	Symb_On			;      

Symb_2_On
		movf	Brightness,w
		btfsc	Flash,6			;    2- 
		movwf	TMR0			;      TMR0

		movlw	b'11100010'		; W    2- 
		movwf	LED_Num			;     
		movf	Symbol_2,w		;  W    2- 
;		movwf	Symb_Code		;    
		goto	Symb_On			;      

Symb_3_On
		movf	Brightness,w
		btfsc	Flash,5			;    3- 
		movwf	TMR0			;      TMR0

		movlw	b'11100100'		; W    3- 
		movwf	LED_Num			;    
		movf	Symbol_3,w		;  W    3- 
;		movwf	Symb_Code		;    
		goto	Symb_On			;      

Symb_4_On
		movf	Brightness,w
		btfsc	Flash,4			;    4- 
		movwf	TMR0			;      TMR0

		movlw	b'11101000'		; W    4- 
		movwf	LED_Num			;    
		movf	Symbol_4,w		;  W    4- 
;		movwf	Symb_Code		;    
		goto	Symb_On			;      

Symb_5_On
		movf	Brightness,w
		btfsc	Flash,3			;    5- 
		movwf	TMR0			;      TMR0

		movlw	b'11110000'		; W    5- 
		movwf	LED_Num			;    
		movf	Symbol_5,w		;  W    5- 
;		movwf	Symb_Code		;    
		goto	Symb_On			;      

Symb_6_On
		movf	Brightness,w
		btfsc	Flash,2			;    6- 
		movwf	TMR0			;      TMR0

		movlw	b'11000000'		; W    6- 
		movwf	LED_Num			;    
		movf	Symbol_6,w		;  W    6- 
;		movwf	Symb_Code		;    
		goto	Symb_On			;      

Symb_7_On
		movf	Brightness,w
		btfsc	Flash,1			;    7- 
		movwf	TMR0			;      TMR0

		movlw	b'10100000'		; W    7- 
		movwf	LED_Num			;    
		movf	Symbol_7,w		;  W    7- 
;		movwf	Symb_Code		;    
		goto	Symb_On			;      

Symb_8_On
		movf	Brightness,w
		btfsc	Flash,0			;    8- 
		movwf	TMR0			;      TMR0

		movlw	b'01100000'		; W    8- 
		movwf	LED_Num			;    
		movf	Symbol_8,w		;  W    8- 
;		movwf	Symb_Code		;    
		goto	Symb_On			;      

Symb_On
		; 
;		movf	Symb_Code,w		;  W     
		call	LED_Table		;     " "
		movwf	PORTB			;      
								
		bcf 	PORTB,Heat		;   
	;      !!!!!!
		btfsc	Heat_On
;		btfsc	PWM_Tick
		bsf 	PORTB,Heat		

		bsf		PORTA_temp,2
		call	Out_PORTA		;   B  
		bcf		PORTA_temp,2	;  
		call	Out_PORTA

		movf	LED_Num,w		;  
		movwf	PORTB

		bsf		PORTA_temp,3	;   B  
		call	Out_PORTA		;  
		bcf		PORTA_temp,3
		call	Out_PORTA

		call	Buttons			; 
		call	Butt_Fronts		;   
		call	SetMode			;   (   Butt_Fronts)

		goto	Exit_Int

Symb_Off
		; 
		movlw	b'11100000'		;  
		movwf	PORTB
		bsf		PORTA_temp,3
		call	Out_PORTA
		bcf		PORTA_temp,3
		call	Out_PORTA
		movlw	.200			;,       (255-200=55)
		movwf	TMR0

Exit_Int
		incf	Timer_1,f		;    1
		skpz
		goto	$+3
		incf	Timer_2,f		;      		
		incf	Key_Timer,f		;      

		incf	Int_Counter,f	;  
		movlw	h'10'			;  10H,    ,
		xorwf	Int_Counter,w	;  
		btfsc	STATUS,Z		;
		clrf	Int_Counter

		movlw	h'40'			;  Brightness
		addwf	Br_prescaler,f
		btfsc	STATUS,C		;  ,    1 Brightness
		incf	Brightness,f	;   
		movlw	h'FA'			;  FAH,    ,
		xorwf	Brightness,w	; 
		btfss	STATUS,Z		;
		goto	Restore_Regs
		movlw	h'90'
		movwf	Brightness		;   

		bcf 	PORTA,1			;  SDA (    )

Restore_Regs
		;---     
		swapf	status_temp,w	;   status_temp
								;  w,    
		movwf	STATUS			;  w   STATUS
		swapf	w_temp,F		;    w_temp
		swapf	w_temp,w		;    w_temp    w		


		retfie					;   
;   


;      
; :   W   0  FF
; :   W   
LED_Table
;		movwf	temp
;		movlw	HIGH LED_Sector
;		movwf	PCLATH
;		clrf	PCLATH			;     
;		movf	temp,w
LED_Sector
		addwf	PCL,f			;W + PC -> PC
		retlw	b'00111111'		; ..FEDCBA = '0'  00H
		retlw	b'00000110'		; .....CB. = '1'  01H
		retlw	b'01011011'		; .G.ED.BA = '2'  02H
		retlw	b'01001111'		; .G..DCBA = '3'  03H
		retlw	b'01100110'		; .GF..CB. = '4'  04H
		retlw	b'01101101'		; .GF.DC.A = '5'  05H
		retlw	b'01111101'		; .GFEDC.A = '6'  06H
		retlw	b'00000111'		; .....CBA = '7'  07H
		retlw	b'01111111'		; .GFEDCBA = '8'  08H
		retlw	b'01101111'		; .GF.DCBA = '9'  09H
		retlw	b'01110111'		; .GFE.CBA = 'A'  0AH
		retlw	b'01111100'		; .GFEDC.. = 'b'  0BH
		retlw	b'00111001'		; ..FED..A = 'C'  0CH
		retlw	b'01011110'		; .G.EDCB. = 'd'  0DH
		retlw	b'01111001'		; .GFED..A = 'E'  0EH
		retlw	b'01110001'		; .GFE...A = 'F'  0FH
		retlw	b'00000000'		; ........ = ' '  10H
		retlw	b'01110110'		; .GFE.CD. = 'H'  11H
		retlw 	b'01000000'		; .G...... = '-'  12H
		retlw 	b'01100011'		; .G.E..BA = 'o'  13H
		retlw	b'01011000'		; .G.ED... = 'c'  14H
		retlw 	b'00110111'		; ..FE.CBA = ''  15H
		retlw 	b'01111000'		; .GFED... = 't'  16H
		retlw 	b'00010000'		; ...E.... = 'i'  17H
		retlw 	b'01110011'		; .GFE..BA = 'P'  18H
		retlw 	b'00011100'		; ...EDC.. = 'u'  19H
		retlw 	b'00110001'		; ..FE...A = ''  1AH
		retlw 	b'00111000'		; ..FED... = 'L'  1BH

Set_Parameter_Case		
;		clrf	PCLATH
		movf	Mode,w			;
		andlw	b'00001111'		;   ,     
S_Par_Case
		addwf	PCL,f
		goto	Set_Par_0
		goto	Set_Par_1
		goto	Set_Par_2
		goto	Set_Par_3
		goto	Set_Par_4
		goto	Set_Par_5
		goto	Set_Par_6
		goto	Set_Par_7
		goto	Set_Par_8
		goto	Set_Par_9
		goto	Set_Par_10
		goto	Set_Par_11
		goto	Set_Par_12
		goto	Set_Par_13
		goto	Set_Par_14

;========================  ==============================
Buttons	
;		movlw	HIGH Btn_Sector
;		movwf	PCLATH
		movf	Int_Counter,w	;      
;		clrf	PCLATH			;     
Btn_Sector
		addwf	PCL,f			;W + PC -> PC
		goto	Btn_1			; Int_Counter=0=>. 1- . =>   1
		nop						; ,   
		goto	Btn_2			; Int_Counter=3=>. 2- . =>   2
		nop						; ,   nop    
		goto	Btn_3			; Int_Counter=5=>. 3- . =>   3
		nop		
		goto	No_Btn			;     ,  ,   
		nop		
		goto	No_Btn
		nop		
		goto	No_Btn
		nop		
		goto	No_Btn
		nop		
		goto	No_Btn



Btn_1	;----------------------- 1- ---------------------------------
		btfsc	PORTA,Key		; ,  .  ,  . .
		goto	B1_Press		;   ...
		clrf	Key_1_Count		;  ->  

		btfsc	Key_1_Pr		;     
		bsf		Key_1_PrR		;    . 

		btfss	Key_1_LP		;     
		goto	$+3	; ,   
		bsf		Key_1_LPR		;     
		bcf		Key_1_PrR		;     . 

		bcf		Key_1_Pr  		;   1- 
		bcf		Key_1_LP
		return 
								
B1_Press
		clrf	Key_Timer		;  (  
								;    , 
								;    
		incf	Key_1_Count,w	;: ,    Key_Count
		btfsc	STATUS,Z		;,    W,    255  
		return					;Z ,    
		
		incf	Key_1_Count,f	;Z  ,   
		;    
		movlw	Key_Pr			;    
		subwf	Key_1_Count,w	;     
		btfsc	STATUS,Z		; 10-    
		bsf		Key_1_Pr 		;  1- 
		btfsc	STATUS,Z		; 10-   
		bsf		Beep			; 

		movlw	Key_Long		;    
		subwf	Key_1_Count,w	;     
		btfsc	STATUS,Z		; 200-    
		bsf		Key_1_LP		 ;  1- 

		return 

Btn_2	;----------------------- 2- ---------------------------------
		btfsc	PORTA,Key		; ,  . ,  . .
		goto	B2_Press		;   ...
		clrf	Key_2_Count		;  ->  
		bcf		Key_2_Pr  		;   2- 
		bcf		Key_2_LP
		return 
								
B2_Press
;		bsf		Start_Reg
		clrf	Key_Timer		;  (  
								;    , 
								;    
		incf	Key_2_Count,w
		btfsc	STATUS,Z
		return
		incf	Key_2_Count,f
		;    
		movlw	Key_Pr			;    
		subwf	Key_2_Count,w	;     
		btfsc	STATUS,Z		; 10-    
		bsf		Key_2_Pr 		;  2- 
		btfsc	STATUS,Z		; 10-   
		bsf		Beep			; 

		movlw	Key_Long		;    
		subwf	Key_2_Count,w	;     
		btfsc	STATUS,Z		; 200-    
		bsf		Key_2_LP 		;  2- 

		return 

Btn_3	;----------------------- 3- ---------------------------------
		btfsc	PORTA,Key		; ,  . ,  . .
		goto	B3_Press		;   ...
		clrf	Key_3_Count		;  ->  
		bcf		Key_3_Pr 		;   3- 
		bcf		Key_3_LP
		return 
								
B3_Press
		clrf	Key_Timer		;  (  
								;    , 
								;    
		incf	Key_3_Count,w
		btfsc	STATUS,Z
		return
		incf	Key_3_Count,f
		;    
		movlw	Key_Pr			;    
		subwf	Key_3_Count,w	;     
		btfsc	STATUS,Z		; 10-    
		bsf		Key_3_Pr 		;  3- 
		btfsc	STATUS,Z		; 10-   
		bsf		Beep			; 

		movlw	Key_Long		;    
		subwf	Key_3_Count,w	;     
		btfsc	STATUS,Z		; 200-    
		bsf		Key_3_LP 		;  3- 

		return 

;         (  )
No_Btn	
		nop
		nop
		nop
		nop
		return
;======================   =========================


;======================    =============
Butt_Fronts
		movf	Keyb_Status,w	;   
		xorwf	Keyb_Last_St,w	;     
								;   ,  
		andwf	Keyb_Status,w	;  ,    0  1
;          
;    1, ..       , 
;  2  3    ,     
; 2   ,         
;      2  3   ,  
;,    

		iorwf	Keyb_Fronts,f	;     

		andlw	b'00001001'		;
		iorlw	b'11110110'
		andwf	Keyb_Fronts,F

		movf	Keyb_Status,w	;   
		movwf	Keyb_Last_St	;     
		return
;================     =============


;======================  ===============================
SetMode
		btfsc	T_Corr			;   -  
		goto	T_C_Set_Mode	;    
		btfsc	Set_Par			;    
		goto	S_P_Set_Mode	;   
								;   ,  ,    
								; 
;   
		btfss	K_1_Pr_Fr		;    1- 
		goto	$+4
		bsf		T_Corr			;     ()
		movlw	b'01000000'
		andwf	Keyb_Fronts,f	;     ,  beep  

		btfss	K_1_LP_Fr		;    1- 
		goto	$+4
;		bcf		T_Corr			;    		
		movlw	b'01000000'
		andwf	Keyb_Fronts,f	;     ,  beep  
		bsf		Set_Par			;    

		return
;     
T_C_Set_Mode
		btfsc	Key_Timer,5		;    6- ,  
		clrf	Mode			;    ->    

		btfss	K_1_LP_Fr		;    1- 
		goto	$+4
		clrf	Mode			;    		
		bsf		Set_Par			;    
		return
								;     
								;    

		btfss	K_1_Pr_Fr		;    1- 
		return					;    

		incf	Mode,f			;    1 ( ->->)
								;Mode='10000000' -  
								;Mode='10000001' -  
								;Mode='10000010' -  
		movlw	b'10000011'		;    , 
		xorwf	Mode,w			; ,   w 
		skpnz
		clrf	Mode			;     
		return

;     
S_P_Set_Mode
		btfsc	Key_Timer,5		;    6- ,  
		clrf	Mode			;    ->    

		btfss	K_1_LP_Fr		;    1- 
		goto	$+3
		clrf	Mode			;     		
		return

		btfss	K_1_Pr_Fr		;    1- 
		return					;    

		incf	Mode,f			;    1 ( )
								;Mode='01000000'    
								;Mode='01000001'   
								;Mode='01000010'    
								;Mode='01000011'    (0- 1- 2-)
								;Mode='01000100'     t0
								;Mode='01000101'      
								;Mode='01000110'  
								;Mode='01000111'  
								;Mode='01001000'  
								;Mode='01001001'  
								;Mode='01001010'  


		movlw	b'01001111'		;    ,
		xorwf	Mode,w			; ,   w 
		skpz
		return
		movlw	b'01000000';
		movwf	Mode			;   
		return



;======================   ==========================


;  
main

; 
		clrf 	STATUS
		bsf		STATUS,RP0		;   
		movlw	INIT_PORTA
		movwf	TRISA ^80H		;   A
		movlw	INIT_PORTB
		movwf	TRISB ^80H		;   B		
		movlw	INIT_OPTION
		movwf	OPTION_REG ^80H	;  OPTION_REG	
		clrf	VRCON ^80H		;    
		bcf		STATUS,RP0		;   

		movlw	INIT_INTCON		;  INTCON
		movwf	INTCON			;
		movlw	INIT_CMCON		;   
		movwf	CMCON
		clrf	T1CON			; TMR1
		clrf	T2CON			; TMR2
		clrf	CCP1CON			;  CCP
		clrf	RCSTA			; UART

;		bsf		STATUS,RP0		;   

		clrf	PORTA_temp
		movlw	b'11100000'
		movwf	PORTB
		bsf		PORTA,3
		clrf	PORTA
		clrf	Int_Counter		;  
		clrf	Keyb_Status		;  
		clrf	Brightness		;  - 
		clrf	Br_prescaler	;  
		clrf	Flash			;    
		clrf	Keyb_Status		;  
		clrf	Keyb_Last_St	;     
		clrf	Keyb_Fronts		;    Keyb_Status
		clrf	Mode			;   
		clrf	Timer_1			; 
		clrf	Timer_2
		clrf	Access_Level
		call	Load_Config
		call	Reg_Init

		clrf	DS_Control
		bsf		Sound_Out
		call	Write_Ctrl_DS1307

		call	Init_TCNs		; 
		call	ReadTemps		;   

		clrf	PWM
		movlw	.100
		movwf	PWM_Count
		call	PWM_Routine		;      

		movlw	h'00'
		movwf	Symbol_1
		movlw	h'00'
		movwf	Symbol_2
		movlw	h'00'
		movwf	Symbol_3
		movlw	h'00'
		movwf	Symbol_4
		movlw	h'00'
		movwf	Symbol_5
		movlw	h'00'
		movwf	Symbol_6
		movlw	h'00'
		movwf	Symbol_7
		movlw	h'00'
		movwf	Symbol_8
		bsf		INTCON,GIE		; 


;   
Loop
		btfsc	Beep_En			;   , 
		call	Key_Beep		;   
		call	Read_Time_DS1307;     , ..    
;		call	Regulator		;   

		btfss 	PWM_Tick		;  ,
		goto	$+3
		call	ReadTemps		;    
		call	PWM_Routine		;      

		btfsc	Set_Par			;    
		goto	Set_Par_Mode	;    

		btfsc	T_Corr			;    
		goto	T_Corr_Mode		;    

;     (    )
		clrf	Flash			;   
		btfsc	Timer_2,4		; 4-    1,   ,
		goto	Main_Mode_Temp	;   0,    

		;  

		call	Disp_Time		;    
		goto	Loop

		;   
Main_Mode_Temp
		call	Disp_Temp		
		goto	Loop

;####################################################################
T_Corr_Mode		;  
		call	Read_Time_DS1307
		call	Disp_Time		;  

		movlw	b'10000000'
		xorwf	Mode,w
		skpnz
		goto	Hour_corr		;  

		movlw	b'10000001'
		xorwf	Mode,w
		skpnz
		goto	Min_corr		;  

		movlw	b'10000010'
		xorwf	Mode,w
		skpnz
		goto	Sec_corr		;  
		
		goto	$+2				;    ,    

T_Corr_End ;   -    DS1307 
		call	Write_Time_DS1307
		goto	Loop			;        

;  
Hour_corr
		movlw	b'11000000'
		movwf	Flash			;  

		btfsc	K_2_Pr_Fr		;    2 (-)
		goto	Hr_Dn
		btfsc	Key_2_LP		;     2 (-)
		goto	Hr_Dn

		btfsc	K_3_Pr_Fr		;    3 (+)
		goto	Hr_Up
		btfsc	Key_3_LP		;     3 (+)
		goto	Hr_Up
		goto	Loop

Hr_Dn
		bcf 	K_2_Pr_Fr		; 

		movlw	h'01'
		subwf	Hours,f			;   1
		skpnc					;    ,    
		goto	$+4				;   
		movlw	h'23'			;  FF  23  
		movwf	Hours
		goto	$+8				;      DS1307
		;      
		movf	Hours,w			;     0,     F
		andlw	b'00001111'		;   
		xorlw	b'00001111'		;,     F
		skpz
		goto	$+3				;  ,       DS1307
		movlw	b'11111001'		;  ,    F ,
		andwf	Hours,f			;   1  2

		goto	T_Corr_End
Hr_Up
		bcf 	K_3_Pr_Fr		; 

		incf	Hours,f			;   1
		movf	Hours,w
		andlw	b'00001111'
		xorlw	.10
		skpz					;    
		goto	$+05			;    

								;    ,  
		movlw	b'11110000'
		andwf	Hours,f			; 
		movlw	b'00010000'		;    
		addwf	Hours,f			;    1

		;    ,      
		movlw	b'00100100'		; 24  (24H)
		xorwf	Hours,w
		skpz
		goto	$+2				;   ,    
		clrf	Hours			;  ,    

		goto	T_Corr_End


;  
Min_corr
		movlw	b'00011000'
		movwf	Flash			;  

		btfsc	K_2_Pr_Fr		;    2 (-)
		goto	Min_Dn
		btfsc	Key_2_LP		;     2 (-)
		goto	Min_Dn

		btfsc	K_3_Pr_Fr		;    3 (+)
		goto	Min_Up
		btfsc	Key_3_LP		;     3 (+)
		goto	Min_Up
		goto	Loop

Min_Dn
		bcf 	K_2_Pr_Fr		; 
		movlw	h'01'
		subwf	Minutes,f		;   1
		skpnc					;    ,    
		goto	$+4				;   
		movlw	h'59'			;  FF  59 
		movwf	Minutes
		goto	$+8				;      DS1307
		;      
		movf	Minutes,w		;     0,     F
		andlw	b'00001111'		;   
		xorlw	b'00001111'		;,     F
		skpz
		goto	$+3				;  ,       DS1307
		movlw	b'11111001'		;  ,    F ,
		andwf	Minutes,f		;   1  2

		goto	T_Corr_End
Min_Up
		bcf 	K_3_Pr_Fr		; 

		incf	Minutes,f		;   1
		movf	Minutes,w
		andlw	b'00001111'
		xorlw	.10
		skpz					;    
		goto	$+05			;    

								;    ,  
		movlw	b'11110000'
		andwf	Minutes,f		; 
		movlw	b'00010000'		;    
		addwf	Minutes,f		;    1

		;    ,     
		movlw	b'01100000'		; 60  (60H)
		xorwf	Minutes,w
		skpz
		goto	$+2				;   ,    
		clrf	Minutes			;  ,   

		goto	T_Corr_End

;  
Sec_corr
		movlw	b'00000111'
		movwf	Flash			;  

		btfsc	K_2_Pr_Fr		;    2  3
		goto	$+4				;  
		btfsc	K_3_Pr_Fr		;  
		goto	$+2
		goto	Loop

		bcf 	K_2_Pr_Fr		;   
		bcf 	K_3_Pr_Fr		;     
		clrf	Seconds
		bsf		Sec_Corr		;   
		call	Write_Time_DS1307 ; 
		bcf		Sec_Corr		;   

		goto	Loop			;        


;####################################################################
;  
Set_Par_Mode
		movlw	h'15'			;  ""
		movwf	Symbol_6		;  6- 
		movlw	b'00111111'
		andwf	Mode,w			;     
		clrf	bin1
		movwf	bin2
		call	Bin2BCD_16		;    
		;     99,      bcd3
		swapf	bcd3,w
		andlw	b'00001111'		;  bcd3 
		movwf	Symbol_7		;    7 
		movf	bcd3,w
		andlw	b'00001111'		;  bcd3 
		movwf	Symbol_8		;    8 		
		goto	Set_Parameter_Case	;        
								;     

Set_Par_0	; 
		;    SEC_
		movlw	h'05'			;5=S
		movwf	Symbol_1
		movlw	h'0E'			;E
		movwf	Symbol_2
		movlw	h'0C'			;C
		movwf	Symbol_3
		movlw	h'10'			; 
		movwf	Symbol_4
		movlw	b'00001000'
		movwf	Flash			;  
		movf	Access_Level,w
		movwf	Symbol_5		;   
		btfsc	K_2_Pr_Fr		;    2
		goto	Par_0_Dec		;    
		btfsc	K_3_Pr_Fr		;    3
		goto	Par_0_Inc		;    
		goto	Loop			;   ,  
Par_0_Dec
		bcf 	K_2_Pr_Fr		; 
		decf	Access_Level,w	;  1  
		xorlw	h'FF'
		skpz					;   ,   
		decf	Access_Level,f	;  ,  
		goto	Loop
Par_0_Inc
		bcf 	K_3_Pr_Fr		; 
		incf	Access_Level,w	;  1  
		xorlw	h'03'
		skpz					;   ,   
		incf	Access_Level,f	;  ,  
		goto	Loop

Set_Par_1	; 
		;    tiC_
		movlw	h'16'			;t
		movwf	Symbol_1
		movlw	h'17'			;i
		movwf	Symbol_2
		movlw	h'0C'			;C
		movwf	Symbol_3
		movlw	h'10'			;
		movwf	Symbol_4
		movlw	b'00001000'
		movwf	Flash			;  
		movlw	h'00'
		btfsc	Sound_En		;  
		iorlw	h'01'			;    1
		movwf	Symbol_5		

		btfsc	K_2_Pr_Fr		;    2
		bcf 	Sound_En		; 
		btfsc	K_3_Pr_Fr		;    3
		bsf 	Sound_En		; 

		bcf		K_2_Pr_Fr	
		bcf		K_3_Pr_Fr		;  

		call	Write_Ctrl_DS1307 ;    DS1307
		goto	Loop

Set_Par_2	;   
		;    butt
		movlw	h'0b'			;b
		movwf	Symbol_1
		movlw	h'19'			;u
		movwf	Symbol_2
		movlw	h'16'			;t
		movwf	Symbol_3
		movlw	h'16'			;t
		movwf	Symbol_4
		movlw	b'00001000'
		movwf	Flash			;  
		movlw	h'00'
		btfsc	Beep_En			;  
		iorlw	h'01'			;    1
		movwf	Symbol_5		

		btfsc	K_2_Pr_Fr		;    2
		bcf 	Beep_En			; 
		btfsc	K_3_Pr_Fr		;    3
		bsf 	Beep_En			; 

		bcf		K_2_Pr_Fr	
		bcf		K_3_Pr_Fr		;  
		goto	Loop

Set_Par_3 ;   (0- 1- 2-)
		;    PE
		movlw	h'18'			;
		movwf	Symbol_1
		movlw	h'0E'			;
		movwf	Symbol_2
		movlw	h'1A'			;
		movwf	Symbol_3
		movlw	h'10'			;
		movwf	Symbol_4

		movlw	h'18'			; 
		btfsc	Reg_Auto		;   
		movlw	h'0A'			;   ,    ""
		movwf	Symbol_5		;   5- 

		btfss	Access_Level,1	;      
		clrf	Flash			; 
		btfss	Access_Level,1	;      
		goto	Loop			;         

		movlw	b'00001000'
		movwf	Flash			;  
		btfsc	K_2_Pr_Fr		;    2
		goto	Par_3_Dec		;    
		btfsc	K_3_Pr_Fr		;    3
		goto	Par_3_Inc		;    
		goto	Loop			;   ,  
		

Par_3_Dec
		bcf		K_2_Pr_Fr		;  	
		bcf 	Reg_Auto		;    
		goto	Loop
Par_3_Inc
		bcf		K_3_Pr_Fr
		bsf 	Reg_Auto		;    
		goto	Loop

Set_Par_4 ;    t0
		;   to
		movlw	h'16'			;t
		movwf	Symbol_1
		movlw	h'13'			;o
		movwf	Symbol_2

		clrf	bin1
		movf	Need_Temp,w			;   Kp
		movwf	bin2
		call	Bin2BCD_16		;   
		call	Show_Par		;   

		btfss	Access_Level,1	;     
		goto	Loop			;     ,   

		;     
		movlw	b'00011000'
		movwf	Flash			;    

		btfsc	K_2_Pr_Fr		;    2
		goto	Par_4_Dec		;    
		btfsc	Key_2_LP		;     2 (-)
		goto	Par_4_Dec		;    

		btfsc	K_3_Pr_Fr		;    3
		goto	Par_4_Inc		;    
		btfsc	Key_3_LP		;    3
		goto	Par_4_Inc		;    

		goto	Loop			;   ,  
Par_4_Dec
		call	Delay_1mS
		bcf 	K_2_Pr_Fr		; 
		decf	Need_Temp,w		;  1  
		xorlw	.255
		skpz					;   ,   
		decf	Need_Temp,f		;  ,  
		goto	Loop
Par_4_Inc
		call	Delay_1mS
		bcf 	K_3_Pr_Fr		; 
		incf	Need_Temp,w		;  1  
		xorlw	.50
		skpz					;   ,   
		incf	Need_Temp,f		;  ,  

		goto	Loop

Set_Par_5 ;     
		movf	Access_Level,f	;    0 (   )
		skpz
		goto	$+4				;   
		movlw	b'01000000'		;   
		movwf	Mode
		goto	Loop			;     	
		
		;   Out
		movlw	h'00'			;0
		movwf	Symbol_1
		movlw	h'19'			;u
		movwf	Symbol_2
;		movlw	h'16'			;t

		clrf	Flash
		clrf	bin1
		movf	PWM,w			;   
		movwf	bin2
		call	Bin2BCD_16		;   
		call	Show_Par		;   		

		btfss	Access_Level,1	;     
		goto	Loop			;     ,   
		btfsc	Reg_Auto		;  
		goto	Loop			;     ,   

		;           
		movlw	b'00111000'
		movwf	Flash			;     

		btfsc	K_2_Pr_Fr		;    2
		goto	Par_5_Dec		;    
		btfsc	Key_2_LP		;     2 (-)
		goto	Par_5_Dec		;    

		btfsc	K_3_Pr_Fr		;    3
		goto	Par_5_Inc		;    
		btfsc	Key_3_LP		;    3
		goto	Par_5_Inc		;    

		goto	Loop			;   ,  
Par_5_Dec
		call	Delay_1mS
		bcf 	K_2_Pr_Fr		; 
		decf	PWM,w			;  1  
		xorlw	.255
		skpz					;   ,   
		decf	PWM,f			;  ,  
		goto	Loop
Par_5_Inc
		call	Delay_1mS
		bcf 	K_3_Pr_Fr		; 
		incf	PWM,w			;  1  
		xorlw	.101
		skpz					;   ,   
		incf	PWM,f			;  ,  

		goto	Loop
Set_Par_6 ; 
		;   LP
		movlw	h'1B'			;L
		movwf	Symbol_1
		movlw	h'19'			;u
		movwf	Symbol_2

		clrf	bin1
		movf	Ku,w			;   Ku
		movwf	bin2
		call	Bin2BCD_16		;   
		call	Show_Par		;   

		btfss	Access_Level,1	;     
		goto	Loop			;     ,   

		;      
		movlw	b'00111000'
		movwf	Flash			;     

		btfsc	K_2_Pr_Fr		;    2
		goto	Par_6_Dec		;    
		btfsc	Key_2_LP		;     2 (-)
		goto	Par_6_Dec		;    

		btfsc	K_3_Pr_Fr		;    3
		goto	Par_6_Inc		;    
		btfsc	Key_3_LP		;    3
		goto	Par_6_Inc		;    

		goto	Loop			;   ,  

Par_6_Dec
		call	Delay_1mS
		bcf 	K_2_Pr_Fr		; 
		decf	Ku,w			;  1  
		xorlw	.255
		skpz					;   ,   
		decf	Ku,f			;  ,  
		goto	Loop
Par_6_Inc
		call	Delay_1mS
		bcf 	K_3_Pr_Fr		; 
		incf	Ku,w			;  1  
		xorlw	.201
		skpz					;   ,   
		incf	Ku,f			;  ,  
		goto	Loop

Set_Par_7 ; 
		;   Li
		movlw	h'1B'			;L
		movwf	Symbol_1
		movlw	h'17'			;i
		movwf	Symbol_2

		clrf	bin1
		movf	Ku,w			;   Ku
		movwf	bin2
		call	Bin2BCD_16		;   
		call	Show_Par		;   

		btfss	Access_Level,1	;     
		goto	Loop			;     ,   

		;      
		movlw	b'00111000'
		movwf	Flash			;     

		btfsc	K_2_Pr_Fr		;    2
		goto	Par_7_Dec		;    
		btfsc	Key_2_LP		;     2 (-)
		goto	Par_7_Dec		;    

		btfsc	K_3_Pr_Fr		;    3
		goto	Par_7_Inc		;    
		btfsc	Key_3_LP		;    3
		goto	Par_7_Inc		;    

		goto	Loop			;   ,  

Par_7_Dec
		call	Delay_1mS
		bcf 	K_2_Pr_Fr		; 
		decf	Ku,w			;  1  
		xorlw	.255
		skpz					;   ,   
		decf	Ku,f			;  ,  
		goto	Loop
Par_7_Inc
		call	Delay_1mS
		bcf 	K_3_Pr_Fr		; 
		incf	Ku,w			;  1  
		xorlw	.201
		skpz					;   ,   
		incf	Ku,f			;  ,  
		goto	Loop

Set_Par_8 ; 
		;   ti
		movlw	h'16'			;t
		movwf	Symbol_1
		movlw	h'17'			;i
		movwf	Symbol_2

		clrf	bin1
		movf	Ti,w			;   Ti
		movwf	bin2
		call	Bin2BCD_16		;   
		call	Show_Par		;   

		btfss	Access_Level,1	;     
		goto	Loop			;     ,   

		;      
		movlw	b'00111000'
		movwf	Flash			;     

		btfsc	K_2_Pr_Fr		;    2
		goto	Par_8_Dec		;    
		btfsc	Key_2_LP		;     2 (-)
		goto	Par_8_Dec		;    

		btfsc	K_3_Pr_Fr		;    3
		goto	Par_8_Inc		;    
		btfsc	Key_3_LP		;    3
		goto	Par_8_Inc		;    

		goto	Loop			;   ,  

Par_8_Dec
		call	Delay_1mS
		bcf 	K_2_Pr_Fr		; 
		decf	Ti,w			;  1  
		xorlw	.255
		skpz					;   ,   
		decf	Ti,f			;  ,  
		goto	Loop
Par_8_Inc
		call	Delay_1mS
		bcf 	K_3_Pr_Fr		; 
		incf	Ti,w			;  1  
		xorlw	.21
		skpz					;   ,   
		incf	Ti,f			;  ,  
		goto	Loop

Set_Par_9 ; 
		;   Ld
		movlw	h'1B'			;L
		movwf	Symbol_1
		movlw	h'0D'			;d
		movwf	Symbol_2

		clrf	bin1
		movf	Ku,w			;   Ku
		movwf	bin2
		call	Bin2BCD_16		;   
		call	Show_Par		;   

		btfss	Access_Level,1	;     
		goto	Loop			;     ,   

		;      
		movlw	b'00111000'
		movwf	Flash			;     

		btfsc	K_2_Pr_Fr		;    2
		goto	Par_9_Dec		;    
		btfsc	Key_2_LP		;     2 (-)
		goto	Par_9_Dec		;    

		btfsc	K_3_Pr_Fr		;    3
		goto	Par_9_Inc		;    
		btfsc	Key_3_LP		;    3
		goto	Par_9_Inc		;    

		goto	Loop			;   ,  

Par_9_Dec
		call	Delay_1mS
		bcf 	K_2_Pr_Fr		; 
		decf	Ku,w			;  1  
		xorlw	.255
		skpz					;   ,   
		decf	Ku,f			;  ,  
		goto	Loop
Par_9_Inc
		call	Delay_1mS
		bcf 	K_3_Pr_Fr		; 
		incf	Ku,w			;  1  
		xorlw	.201
		skpz					;   ,   
		incf	Ku,f			;  ,  	
		goto	Loop

Set_Par_10 ; 
		;   td
		movlw	h'16'			;t
		movwf	Symbol_1
		movlw	h'0D'			;d
		movwf	Symbol_2

		clrf	bin1
		movf	Td,w			;   Td
		movwf	bin2
		call	Bin2BCD_16		;   
		call	Show_Par		;   

		btfss	Access_Level,1	;     
		goto	Loop			;     ,   

		;      
		movlw	b'00111000'
		movwf	Flash			;     

		btfsc	K_2_Pr_Fr		;    2
		goto	Par_10_Dec		;    
		btfsc	Key_2_LP		;     2 (-)
		goto	Par_10_Dec		;    

		btfsc	K_3_Pr_Fr		;    3
		goto	Par_10_Inc		;    
		btfsc	Key_3_LP		;    3
		goto	Par_10_Inc		;    

		goto	Loop			;   ,  

Par_10_Dec
		call	Delay_1mS
		bcf 	K_2_Pr_Fr		; 
		decf	Td,w			;  1  
		xorlw	.255
		skpz					;   ,   
		decf	Td,f			;  ,  
		goto	Loop
Par_10_Inc
		call	Delay_1mS
		bcf 	K_3_Pr_Fr		; 
		incf	Td,w			;  1  
		xorlw	.21
		skpz					;   ,   
		incf	Td,f			;  ,  	
		goto	Loop

Set_Par_11
		call	Save_Config
		movlw	b'01000000'
		movwf	Mode
		goto	Loop
Set_Par_12
	
		goto	Loop
Set_Par_13
	
		goto	Loop
Set_Par_14
	
		goto	Loop



;============== =========================
;       PORTA_temp
;   -      
;        ,    
;   ,         8 
Out_PORTA
		movf	PORTA_temp,w
		movwf	PORTA
		return
;        PORTA_temp

;  20 
Delay_1mS
		movlw 	h'FF'
		movwf	Del_Counter
		movlw 	h'40'
		movwf	Del_Counter2
Del_loop_1mS
		decfsz	Del_Counter,f
		goto	Del_loop_1mS
		decfsz	Del_Counter2,f
		goto	Del_loop_1mS
		return		
;   

	#include <I2C.asm>;==============   I2C==============
;	messg	"I2C  "

;     DS1307
Read_Time_DS1307
		call	i2c_start
		movlw	RTC_Adress
		movwf	i2c_adress
		call	i2c_adress_send	;  DS1307
		call	i2c_reseive_ack	;    
		movlw	h'00'			;    DS1307
		movwf	i2c_data		;     
		call	i2c_byte_send	;      
		call	i2c_reseive_ack	;    
		call	i2c_stop		;     

		call	i2c_start		;  3  (, , )
		movlw	RTC_Adress
		movwf	i2c_adress
		bsf		i2c_adress,0	;     
		call	i2c_adress_send	;  DS1307
		call	i2c_reseive_ack	;    

		call	i2c_byte_reseive;  
		call	i2c_send_ack
		movf	i2c_data,w
		;      ,     
		xorwf	Seconds,w
		skpz
		bsf		PWM_Tick		;    
		movf	i2c_data,w		
		movwf	Seconds			;  


		call	i2c_byte_reseive;  
		call	i2c_send_ack
		movf	i2c_data,w
		movwf	Minutes			;  


		call	i2c_byte_reseive;  
		; Ack    ,  DS1307  
		call	i2c_send_no_ack
		call	i2c_stop		;    i2c
		movf	i2c_data,w
		movwf	Hours			;  

		return
;      DS1307

;     DS1307
Write_Time_DS1307
		call	i2c_start
		movlw	RTC_Adress
		movwf	i2c_adress
		call	i2c_adress_send	;  DS1307
		call	i2c_reseive_ack	;    
		movlw	h'00'			;    DS1307

		btfss	Sec_Corr		;   ,    
		addlw	h'01'			;  ,   ,  
								
		movwf	i2c_data		;     
		call	i2c_byte_send	;      
		call	i2c_reseive_ack	;    


		btfss	Sec_Corr		;   
		goto	Wr_Min			;   
;  3  (, , )
		movf	Seconds,w		;    
		movwf	i2c_data		;  
		call	i2c_byte_send	;     
		call	i2c_reseive_ack	;    
	
Wr_Min	movf	Minutes,w		;    
		movwf	i2c_data		;  
		call	i2c_byte_send	;     
		call	i2c_reseive_ack	;    

		movf	Hours,w			;    
		movwf	i2c_data		;  
		call	i2c_byte_send	;     
		call	i2c_reseive_ack	;    

		call	i2c_stop		;    

		return
;      DS1307

;    DS1307
Write_Ctrl_DS1307
		call	i2c_start
		movlw	RTC_Adress
		movwf	i2c_adress
		call	i2c_adress_send	;  DS1307
		call	i2c_reseive_ack	;    
		movlw	h'07'			;  Control
		movwf	i2c_data		;     
		call	i2c_byte_send	;      
		call	i2c_reseive_ack	;    

;   
		movf	DS_Control,w	;    
		movwf	i2c_data		;  
		call	i2c_byte_send	;     
		call	i2c_reseive_ack	;    
	
		call	i2c_stop		;    

		return
;     DS1307

;       
Key_Beep
		btfss	Beep
		return
		bcf 	Beep
		movf	DS_Control,w
		movwf	temp
		bsf		Sound_8k
		bsf		Sound_En
		call	Write_Ctrl_DS1307
		movf	temp,w
		movwf	DS_Control
		call	Write_Ctrl_DS1307
		return

Disp_Time
;       
		; 
;		btfss	Seconds,0		; 0-  0, 
		movlw	h'10'			; 3  
		btfsc	Seconds,0		; 0-  1, 
		movlw	h'12'			;  '-'
		movwf	Symbol_3

		movlw	h'14'			; 8-    ""
		movwf	Symbol_8

		movlw	b'00001111'		;   
		andwf	Seconds,w		;   7 
		movwf	Symbol_7		
		swapf	Seconds,w		;     
								;,       0-3
		andlw	b'00001111'		;  4-7 (    (. rrf))
		movwf	Symbol_6		;    6 

		movlw	b'00001111'		;   
		andwf	Minutes,w		;   5 
		movwf	Symbol_5		
		swapf	Minutes,w		;     
								;,       0-3
		andlw	b'00001111'		;  4-7 (    0)
		movwf	Symbol_4		;    4 


		movlw	b'00001111'		;   
		andwf	Hours,w			;   2 
		movwf	Symbol_2		
		swapf	Hours,w			;     
								;,       0-3
		andlw	b'00000011'		;  4-7 (    0)
								; 2-3, .      (. DS1307.pdf)
		skpnz
		movlw	h'10'			;    0,    (10H  )
		movwf	Symbol_1		;    1 

		return
;        

Init_TCNs 
;    TCN75
		movlw	T_1_Adress		;   TCN75
		call	Init_TCN75
		movlw	T_2_Adress		;   TCN75
		call	Init_TCN75
		movlw	T_3_Adress		;   TCN75
		call	Init_TCN75
		return
Init_TCN75
		movwf	i2c_data		;     
		call	i2c_start
		call	i2c_byte_send	;      
		call	i2c_reseive_ack	;    

		movlw	b'00000001'		;Pointer     Config TCN75 (01)
		movwf	i2c_data		; Pointer   
		call	i2c_byte_send	;      
		call	i2c_reseive_ack	;    

		clrf	i2c_data		;   (  0)
		call	i2c_byte_send	;      
		call	i2c_reseive_ack	;    

		call	i2c_stop		;    

		return

Read_TCN75
;   
		call	i2c_start
		call	i2c_adress_send	;    
		call	i2c_reseive_ack	;    

		movlw	b'00000000'		;Pointer     TEMP TCN75 (00)
		movwf	i2c_data		; Pointer   
		call	i2c_byte_send	;      
		call	i2c_reseive_ack	;    

		call	i2c_start		; 
		bsf		i2c_adress,0	;    
		call	i2c_adress_send	;      
		call	i2c_reseive_ack	;    

		call	i2c_byte_reseive;   
		; Ack    ,  TCN75  
		call	i2c_send_no_ack
		call	i2c_stop		;    i2c

		movf	i2c_data,w
		movwf	TCN75_Out

		return
;  Read_TCN75

Temp_Convert
;    ,   
;    temp

		clrf	Temper_10_1		;    
		clrf	Temper_100		;    ( "12H")
		btfss	temp,7			;    (7- )
		goto	Bin_To_BCD		;     Bin->BCD

Negative_t	;    
		movlw	h'12'			;  "-"
		movwf	Temper_100		;      "-"
		;     ,    
		; ,       
		movf	temp,w
		clrf	temp
		subwf	temp,f			;      temp

Bin_To_BCD	;   
		;  
		movlw	.100
L_100	subwf	temp,f			;   
		btfss	STATUS,C		
		goto	Posit_10
		incf	Temper_100,f
		goto	L_100			;   
Posit_10	;  
		addwf	temp,f			;   
		
		movlw	.10
L_10	subwf	temp,f			;   
		btfss	STATUS,C		
		goto	Posit_1
		incf	Temper_10_1,f
		goto	L_10			;   
Posit_1
		addwf	temp,f		;   
		;       
		swapf	Temper_10_1,f	;    
		movf	temp,w
		addwf	Temper_10_1,f	;     
		return

Disp_Temp	;     

		movf	Out_Temp,w		;   
		movwf	temp
		call	Temp_Convert	;     BCD
								;   

		movf	Temper_100,w	;   ""
		skpnz
		movlw	h'10'			;   0,     ( 10H)
		movwf	Symbol_1

		swapf	Temper_10_1,w	;  (   )
		andlw	b'00001111'		; 
		movwf	Symbol_2		;  
		movf	Temper_10_1,w	;    (   )
		andlw	b'00001111'		; 
		movwf	Symbol_3		;  

		movlw	h'13'			; 
		movwf	Symbol_4		;  
		movlw	h'0C'			; "C"
		movwf	Symbol_5		;  

		;     
		movf	Room_Temp,w		;   
		movwf	temp
		call	Temp_Convert	;     BCD
								;   

		movf	Temper_100,w	;   ""
		skpnz
		movlw	h'10'			;   0,     ( 10H)
		movwf	Symbol_6

		swapf	Temper_10_1,w	;  (   )
		andlw	b'00001111'		; 
		movwf	Symbol_7		;  
		movf	Temper_10_1,w	;    (   )
		andlw	b'00001111'		; 
		movwf	Symbol_8		;  
;		goto	Loop
		return

ReadTemps
		movlw	T_1_Adress		;   
		movwf	i2c_adress		;    i2c
		call	Read_TCN75		;   
		movf	TCN75_Out,w
		movwf	Out_Temp		;    

		movlw	T_2_Adress		;   
		movwf	i2c_adress		;    i2c
		call	Read_TCN75		;   
		movf	TCN75_Out,w
		movwf	Room_Temp		;    

		movlw	T_3_Adress		;   
		movwf	i2c_adress		;    i2c
		call	Read_TCN75		;   
		movf	TCN75_Out,w
		movwf	Cur_Temp		;        

		return

; 
Add_16	;   16-  ()
		;   Calc_1Hi  Calc_1Lo
		;   Calc_2Hi  Calc_2Lo
		;         Calc_1Hi  Calc_1Lo

		movf	Calc_2Lo,w		;    
		addwf	Calc_1Lo,f		;       
		skpnc					;     ,
		incf	Calc_1Hi,f		;   1   
		movf	Calc_2Hi,w		;     
		addwf	Calc_1Hi,f		;       
								;     2  
		return
		
Sub_16	;   16- 
		;  Calc_1Hi  Calc_1Lo
		;   Calc_2Hi  Calc_2Lo
		;    Calc_1Hi  Calc_1Lo

		movf	Calc_2Lo,w	;   
		subwf	Calc_1Lo,f	;    
		movf	Calc_2Hi,w	
		skpc				;      
		addlw	h'01'		;      1 
		subwf	Calc_1Hi,f
		return		



Mul_16	;   16- 
		;   Calc_1Hi  Calc_1Lo
		;  Calc_2Hi  Calc_2Lo
		;  Calc_1Hi  Calc_1Lo

		;       
		movf	Calc_1Hi,w
		movwf	Calc_TmpHi
		movf	Calc_1Lo,w
		movwf	Calc_TmpLo

		;  ,    
		clrf	Calc_1Hi
		clrf	Calc_1Lo

		movlw	h'10'			;  +1  (  )
		movwf	Calc_cycle
Mul_Cycle
		btfsc	Calc_TmpLo,0	;     "1", 
		call	Add_16			;   

		;     1    
		bcf		STATUS,C		;    
		rlf		Calc_2Lo,f
		rlf		Calc_2Hi,f
		;   ()   1 
		rrf		Calc_TmpHi,f
		rrf		Calc_TmpLo,f

		;  ,     0,   .
		decf	Calc_cycle,f
		skpz
		goto	Mul_Cycle
		return

Div_16	;   16- 
		;   Calc_1Hi  Calc_1Lo
		;  Calc_2Hi  Calc_2Lo
		;  Calc_1Hi  Calc_1Lo
		
		;  .     .
		clrf	Calc_TmpHi
		clrf	Calc_TmpLo

		;       (+  -)
		btfss	Calc_1Hi,7		;     0 ()
		goto	$+7				;     ,
								;         
		comf	Calc_1Lo,f		;         1
		comf	Calc_1Hi,f		;  
		incf	Calc_1Lo,f
		skpnz					;      16 
		incf	Calc_1Hi,f
		bsf		Calc_1Hi,7		;    

		;   
		btfss	Calc_2Hi,7		;     0 ()
		goto	$+7				;    ,
								;         
		comf	Calc_2Lo,f		;         1
		comf	Calc_2Hi,f		;  
		incf	Calc_2Lo,f
		skpnz					;      16 
		incf	Calc_2Hi,f	
		bsf		Calc_2Hi,7		;    

		;        ,      
		;   
		movf	Calc_1Hi,w		;   
		xorwf	Calc_2Hi,w		;  xor    
		andlw	b'10000000'		;    
		skpz					;    ,    
								; 0 ( )  1 ()
		bsf		Calc_TmpHi,1	;       cn.  
		bcf		Calc_1Hi,7		;   
		bcf		Calc_2Hi,7

		movlw	h'01'			
		movwf	Calc_cycle		;  

		;  :       ,  
		;   1-     .
Zero_Cut
		btfsc	Calc_2Hi,7		;   1,      
		goto	Div_Cycle		;   
								;   16-    1 
		bcf		STATUS,C		;      
		rlf		Calc_2Lo,f
		rlf		Calc_2Hi,f

		;  ,   :      
		;            
		incf	Calc_cycle,f
		;         
		goto	Zero_Cut

Div_Cycle
		;   Calc_1  Calc_2.    Calc_2  Calc_1
		;     w,     ,    
		;   C,    1  Calc_1 > Calc_2,   0  
		; 16-  Calc_2  Calc_1    

		movf	Calc_2Lo,w
		subwf	Calc_1Lo,w
		movf	Calc_2Hi,w
		skpc				;      
		addlw	h'01'		;      1 
		subwf	Calc_1Hi,w

		;   ,   ,   Calc_2 > Calc_1
		;          
		;  ,  1
		skpc				;    
		goto	$+7			;  =0 (  )
		;    ,       (Calc_2)
		;   (  )    (Calc_1)
		;       ,      Calc_1
		movf	Calc_2Lo,w
		subwf	Calc_1Lo,f
		movf	Calc_2Hi,w
		skpc				;      
		addlw	h'01'		;      1 
		subwf	Calc_1Hi,f
		;         
		;            
		rlf		Calc_TmpLo,f
		rlf		Calc_TmpHi,f
		skpnc				;     ,      C
		bsf		Calc_TmpHi,7;    

		decf	Calc_cycle,f;  ,
		skpnz				;    0,
		goto	Out_Div_Res	;   

		;    ,     
		;
		bcf 	STATUS,C		;      
		rrf 	Calc_2Hi,f
		rrf		Calc_2Lo,f
		goto	Div_Cycle

Out_Div_Res
		;   ,    ,    
		btfss	Calc_TmpHi,7;  
		goto	$+7			;  0 ()     
							;  1 ()      
		comf	Calc_TmpHi,f;  ,
		comf	Calc_TmpLo,f
		bsf		Calc_TmpHi,7; 
		incf	Calc_TmpLo,f;     1
		skpnz				;      16 
		incf	Calc_TmpHi,f		

		;   Calc_1
		movf	Calc_TmpHi,w
		movwf	Calc_1Hi
		movf	Calc_TmpLo,w
		movwf	Calc_1Lo
		return
		
Reg_Init
		movlw	h'05'     ;-6 (FA) 			; 
		movwf	Cur_Temp
		clrf	Out_IntHi
		clrf	Out_IntLo
		clrf	Rass_OldHi
		clrf	Rass_OldLo
		return


Regulator	; -
		;    10,       
		;  10.        
		;  10.   =52    - 5,2
		;     0-100,   0-10,0
		;    ,   Ti=8  - 8 

		movf	DS_Control,w
		movwf	temp
		bsf		Sound_4k
		bsf		Sound_En
		call	Write_Ctrl_DS1307
		movf	temp,w
		movwf	DS_Control
		call	Write_Ctrl_DS1307

		;   
		;=(- )*100%/
Rass_Calc	;   
		clrf	Calc_1Hi
		movf	Need_Temp,w
		movwf	Calc_1Lo

		clrf	Calc_2Hi
		btfsc	Cur_Temp,7	;  
		comf	Calc_2Hi,f	;    
		movf	Cur_Temp,w
		movwf	Calc_2Lo
		call	Sub_16		;        

		;   100%
		clrf	Calc_2Hi
		movlw	.100
		movwf	Calc_2Lo
		call	Mul_16

		;      ( TCN75   125-(-55)=180)
		movlw	.180
		movwf	Calc_2Lo
		call	Div_16
		;     
		movf	Calc_1Hi,w
		movwf	Rass_NewHi
		movf	Calc_1Lo,w
		movwf	Rass_NewLo
		;,    

Out_Pr_Calc	;   (  )
		;OutPr = Kp * RassNew
		clrf	Calc_1Hi
		movf	Ku,w
		movwf	Calc_1Lo	; Kp     

		movf	Rass_NewHi,w
		movwf	Calc_2Hi
		movf	Rass_NewLo,w
		movwf	Calc_2Lo	;     

		call	Mul_16		; 
		;  
		movf	Calc_1Hi,w
		movwf	Out_PrHi
		movf	Calc_1Lo,w
		movwf	Out_PrLo
		;  

Out_Int_Calc	;   (  )
		;Out_Int = Int_Summ + ((Ki * T * RassNew) / Ti)
		clrf	Calc_1Hi
		movf	Ku,w
		movwf	Calc_1Lo	; Ki     

		clrf	Calc_2Hi
		movlw	T_Reg_Cycle
		movwf	Calc_2Lo	;      		
		call	Mul_16		; ,    Calc_1

		movf	Rass_NewHi,w
		movwf	Calc_2Hi
		movf	Rass_NewLo,w
		movwf	Calc_2Lo	;  Calc_2   
		call	Mul_16		; ,    Calc_1

		clrf	Calc_2Hi
		movf	Ti,w
		movwf	Calc_2Lo	;      		
		call	Div_16		;      

		; ,   (  Calc_1)      
		;      ,       
		;     Out_Int
		movf	Out_IntHi,w
		movwf	Calc_2Hi
		movf	Out_IntLo,w
		movwf	Calc_2Lo	;  Calc_2    
		call	Add_16		;      (     -)		

		;  
		movf	Calc_1Hi,w
		movwf	Out_IntHi
		movf	Calc_1Lo,w
		movwf	Out_IntLo
		;  

Out_Dif_Calc	;   (  )
		;Out_Dif = (Rass_New - Rass_Old) * Kd * Td / T 
		movf	Rass_NewHi,w
		movwf	Calc_1Hi
		movf	Rass_NewLo,w
		movwf	Calc_1Lo	;      Calc_1
		movf	Rass_OldHi,w
		movwf	Calc_2Hi
		movf	Rass_OldLo,w
		movwf	Calc_2Lo	;      Calc_2
		call	Sub_16		;   

		clrf	Calc_2Hi
		movf	Ku,w
		movwf	Calc_2Lo	; -     		
		call	Mul_16		;      

		clrf	Calc_2Hi
		movf	Td,w
		movwf	Calc_2Lo	;      		
		call	Mul_16		;      

		clrf	Calc_2Hi
		movlw	T_Reg_Cycle
		movwf	Calc_2Lo	;      		
		call	Div_16		;      

		;  
		movf	Calc_1Hi,w
		movwf	Out_DifHi
		movf	Calc_1Lo,w
		movwf	Out_DifLo
		;  

		;     
		movf	Rass_NewHi,w
		movwf	Rass_OldHi
		movf	Rass_NewLo,w
		movwf	Rass_OldLo

Out_Reg_Calc	;    
		;Out_Reg = Out_Pr + Out_Int + Out_Dif
		;      ,     1000.
		;1000  100% . ,         10
		;      

		movf	Out_PrHi,w
		movwf	Calc_1Hi
		movf	Out_PrLo,w
		movwf	Calc_1Lo	;  

		movf	Out_DifHi,w
		movwf	Calc_2Hi
		movf	Out_DifLo,w
		movwf	Calc_2Lo	;  
		call	Add_16		;
		
		;  
		movf	Calc_1Hi,w
		movwf	Out_RegHi
		movf	Calc_1Lo,w
		movwf	Out_RegLo
		;    ,   

		;           
		;,   
		btfsc	Rass_NewHi,7
		goto	Min_Check	

Max_Check
		;     1000,  100%. -  -    
		;  ,       -.   
		;       ,    
		;.      ,      
		;.      1000,     
		;   ,   Out_Pr  Out_Dif
		;     Out_Int = 1000 - (Out_Pr + Out_Dif) 1000(dec)=03E8(hex)

		movlw	h'03'
		movwf	Calc_1Hi
		movlw	h'E8'
		movwf	Calc_1Lo
		movf	Out_RegHi,w
		movwf	Calc_2Hi
		movf	Out_RegLo,w
		movwf	Calc_2Lo
		call	Sub_16		;      Out_Int

		;   Calc_2,    
		movf	Calc_1Hi,w
		movwf	Calc_2Hi
		movf	Calc_1Lo,w
		movwf	Calc_2Lo

		;     Out_Int
		movf	Out_IntHi,w
		movwf	Calc_1Hi
		movf	Out_IntLo,w
		movwf	Calc_1Lo		
		call	Sub_16

		btfsc	Calc_1Hi,7	;   (Out_Int < Max)
		goto	Final_Out_Reg	;     
							;      
							;      Calc_2
		movf	Calc_2Hi,w
		movwf	Out_IntHi
		movf	Calc_2Lo,w
		movwf	Out_IntLo
		goto 	Final_Out_Reg

Min_Check
		;       0,    
		; .         
		;  Out_Int = - (Out_Pr + Out_Dif)
		
		movlw	h'00'
		movwf	Calc_1Hi
		movlw	h'00'
		movwf	Calc_1Lo
		movf	Out_RegHi,w
		movwf	Calc_2Hi
		movf	Out_RegLo,w
		movwf	Calc_2Lo
		call	Sub_16		;      Out_Int

		;   Calc_2,    
		movf	Calc_1Hi,w
		movwf	Calc_2Hi
		movf	Calc_1Lo,w
		movwf	Calc_2Lo

		;     Out_Int
		movf	Out_IntHi,w
		movwf	Calc_1Hi
		movf	Out_IntLo,w
		movwf	Calc_1Lo		
		call	Sub_16

		btfss	Calc_1Hi,7	;   (Out_Int > Min)
		goto	Final_Out_Reg;       
							;      
							;      Calc_2
		movf	Calc_2Hi,w
		movwf	Out_IntHi
		movf	Calc_2Lo,w
		movwf	Out_IntLo
		goto 	Final_Out_Reg


Final_Out_Reg
		;   Out_Pr  Out_Dif   Out_Int ( )
		movf	Out_RegHi,w
		movwf	Calc_1Hi
		movf	Out_RegLo,w
		movwf	Calc_1Lo
		movf	Out_IntHi,w
		movwf	Calc_2Hi
		movf	Out_IntLo,w
		movwf	Calc_2Lo
		call	Add_16

Set_PWM
		;    10,    
		clrf	Calc_2Hi
		movlw	.10
		movwf	Calc_2Lo
		call	Div_16
		;       (    )
		movf	Calc_1Lo,w
		btfsc	Reg_Auto
		movwf	PWM
		; 
		goto	Exit_From_Reg	;   
;		return

PWM_Routine	;     

		incf	PWM_Count,f		;  

		movlw	.101			;    (100%)
		subwf	PWM_Count,w		;    
		skpz
		goto	Compare_PWM		;     
		clrf	PWM_Count		;   101%    
		goto	Regulator		;       
Exit_From_Reg
		movf	PWM,f			;,   PWM   0
		skpz
		bsf		Heat_On			;  

Compare_PWM
		movf	PWM_Count,w		;    ,   
		subwf	PWM,w
		skpc
		bcf 	Heat_On			; ,   
		bcf 	PWM_Tick		;    
		return


Bin2BCD_16
;     BCD ,    ,   
;   -  
		movlw	.16 
		movwf	ctr 
		clrf	bcd1 
		clrf	bcd2 
		clrf	bcd3 
		goto	new_start 
adjdec
		movlw	0x33 
		addwf	bcd1,f 
		addwf	bcd2,f 
		addwf	bcd3,f 

		movlw	0x03 
		btfss	bcd1,3 
		subwf	bcd1,f 
		btfss	bcd2,3 
		subwf	bcd2,f 
		btfss	bcd3,3 
		subwf	bcd3,f 

		movlw	0x30 
		btfss	bcd1,7 
		subwf	bcd1,f 
		btfss	bcd2,7 
		subwf	bcd2,f 
		btfss	bcd3,7 
		subwf	bcd3,f 
new_start
		rlf		bin2,f 
		rlf		bin1,f 
		rlf		bcd3,f 
		rlf		bcd2,f 
		rlf		bcd1,f 
		decfsz	ctr,f 
		goto	adjdec 
		return 

Show_Par ;      3-4-5  ( Bin2BCD_16)
		movf	bcd2,w
		andlw	b'00001111'		;  bcd2 
		skpnz
		movlw	h'10'			;      
		movwf	Symbol_3		;    3 
		swapf	bcd3,w
		andlw	b'00001111'		;  bcd3 
		movwf	Symbol_4		;    4 
		movf	bcd3,w
		andlw	b'00001111'		;  bcd3 
		movwf	Symbol_5		;    5 

		btfss	Access_Level,1	;      
		clrf	Flash			;    
		return

;      DS1307
Save_Config
;		bcf		STATUS,IRP		;  0
		movlw	VarToSave		;  
		movwf	ctr				;  

		movlw	DS_Control		;   
		movwf	FSR				;     

		call	i2c_start
		movlw	RTC_Adress
		movwf	i2c_adress
		call	i2c_adress_send	;  DS1307
		call	i2c_reseive_ack	;    
		movlw	h'07'			;  Control
		movwf	i2c_data		;     
		call	i2c_byte_send	;      
		call	i2c_reseive_ack	;    

		;        DS_Control
		; DS_Control   ,    (  h'07')
Save_Cycle
		movf	INDF,w			; ,     FSR
		movwf	i2c_data		;  
		call	i2c_byte_send	;     
		call	i2c_reseive_ack	;    

		incf	FSR,f			;      
								;  DS1307   
		decfsz	ctr,f			;   1
		goto	Save_Cycle		;     0,  
								;   
		call	i2c_stop		;    I2C
		return

;      DS1307
Load_Config
;		bcf		STATUS,IRP		;  0
		movlw	VarToSave		;  
		movwf	ctr				;  

		movlw	DS_Control		;   
		movwf	FSR				;     

		call	i2c_start
		movlw	RTC_Adress
		movwf	i2c_adress
		call	i2c_adress_send	;  DS1307
		call	i2c_reseive_ack	;    
		movlw	h'07'			;  Control
		movwf	i2c_data		;     
		call	i2c_byte_send	;      
		call	i2c_reseive_ack	;    
		call	i2c_stop		;    I2C

		call	i2c_start		;  DS     
		movlw	RTC_Adress
		movwf	i2c_adress
		bsf		i2c_adress,0	;     
		call	i2c_adress_send	;  DS1307
		call	i2c_reseive_ack	;    


		;        DS_Control
Load_Cycle
		call	i2c_byte_reseive; 
		call	i2c_send_ack
		movf	i2c_data,w

		movwf	INDF			;  
		incf	FSR,f			;      
								;  DS1307   
		decfsz	ctr,f			;   1
		goto	Load_Cycle		;     0,  
								;   
		call	i2c_stop		;    I2C
		return

		END                     ; directive 'end of program'




	
